<?php

include_once(realpath(dirname(__FILE__)) . "/Tva.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");

//Action appelée lors de la modification en masse des tva dans la table produit
if($_POST['action'] == "modifier_tva")
{
    $form_tvas = $_POST['tva_row'];
    if(count($form_tvas) > 0){
        $infos_tva = "";
        $error_tva = array();
        
        $array_produits_id = array();
        //On regroupe les id produit dans des tableaux pour préparer les updates
        //Pour chaque TVA trouvées
        foreach($form_tvas as $num_tva){
            
            $query_produit_id = "SELECT id FROM produit WHERE tva LIKE " . $_POST['tva_old'.$num_tva];
            $result_produits_id = mysql_query($query_produit_id);
            
            $array_produits_id[$num_tva] = array();
            while($row_product_id = mysql_fetch_object($result_produits_id)){
                $array_produits_id[$num_tva][] = $row_product_id->id;   
            }
        }
        
        //Pour chaque TVA trouvées
        foreach($form_tvas as $num_tva){
            if($_POST['tva_new'.$num_tva] != ""){
                if(is_numeric($_POST['tva_new'.$num_tva])){
                    if($_POST['tva_new'.$num_tva] != $_POST['tva_old'.$num_tva]){
                        if($_POST['arrondi'.$num_tva] > 0){
                            //Impacter le changement de la TVA sur nos produits TTC
                            
                            /*
                                Explication du calcul
                                
                                calcul du prix HT:
                                *****************
                                HT + HT*TVA/100 = TTC
                                => HT(1 + TVA/100) == TTC
                                => HT = TTC / (1 + TVA/100)
                                
                                
                                calcul du nouveau montant TTC en fonction de la nouvelle TVA2:
                                *************************************************************
                                TTC = HT + HT*TVA2/100
                                
                                ARRONDI au supérieur:
                                ********************
                                prix = CEILING(prix) => voir la doc mysql
                                
                                astuce pour arrondir au décimal supérieur (même logique pour des précisions plus grandes):
                                *****************************************************************************************
                                prix = CEILING(prix * 10)/10
                                
                                On ne stock que deux chiffres après la virgule dans la bdd:
                                **********************************************************
                                prix = TRUNCATE(prix, 2)
                                
                                
                            */
                            
                            $coef_tva_old = $_POST['tva_old'.$num_tva]/100;
                            $coef_tva_new = $_POST['tva_new'.$num_tva]/100;
                            $query_update = "UPDATE produit SET
                                             prix = TRUNCATE((CEILING(((prix/(1+".$coef_tva_old.")) + (prix/(1+".$coef_tva_old."))*".$coef_tva_new.")*".$_POST['arrondi'.$num_tva].")/".$_POST['arrondi'.$num_tva]."),2),
                                             prix2 = TRUNCATE((CEILING(((prix2/(1+".$coef_tva_old.")) + (prix2/(1+".$coef_tva_old."))*".$coef_tva_new.")*".$_POST['arrondi'.$num_tva].")/".$_POST['arrondi'.$num_tva]."),2),
                                             tva = ".$_POST['tva_new'.$num_tva]."
                                             WHERE id IN (" . implode(",", $array_produits_id[$num_tva]) . ")";
                            mysql_query($query_update);
                            $infos_tva .= "<p class=\"success\">La tva ".$_POST['tva_old'.$num_tva]." a &eacute;t&eacute; chang&eacute;e en tva ".$_POST['tva_new'.$num_tva]." avec succ&egrave;s. Vos prix TTC ont &eacute;t&eacute; mis &agrave; jour.</p>";
                        }else{
                            $query_update = "UPDATE produit SET tva = " . $_POST['tva_new'.$num_tva] . "
                                             WHERE id IN (" . implode(",", $array_produits_id[$num_tva]) . ")";
                            mysql_query($query_update);
                            $infos_tva .= "<p class=\"success\">La tva ".$_POST['tva_old'.$num_tva]." a &eacute;t&eacute; chang&eacute;e en tva ".$_POST['tva_new'.$num_tva]." avec succ&egrave;s.</p>";
                        }   
                    }else{
                        $infos_tva .= "<p class=\"error\">La nouvelle tva (".$_POST['tva_old'.$num_tva].") doit être diff&eacute;rente de l&apos;ancienne.</p>";
                        $error_tva[] = 'tva_new'.$num_tva;
                    }
                }else{
                    $infos_tva .= "<p class=\"error\">La nouvelle tva qui remplace ".$_POST['tva_old'.$num_tva]." n&apos;est pas de type num&eacute;rique ('".$_POST['tva_new'.$num_tva]."').</p>";
                    $error_tva[] = 'tva_new'.$num_tva;
                }
            }else{
                $infos_tva .= "<p>La tva ".$_POST['tva_old'.$num_tva]." n&apos;a pas &eacute;t&eacute; mise &agrave; jour.</p>";
            }
        }
    }
    
    if($_POST['variable_tva_new'] != ""){
        if(is_numeric($_POST['variable_tva_new'])){
            if($_POST['variable_tva_new'] != $_POST['variable_tva_old']){
                $variable_tva = new Variable();
                $variable_tva->charger("tva"); //Compatible thelia 1.3
                $variable_tva->valeur = $_POST['variable_tva_new'];
                $variable_tva->maj();
                $infos_tva .= "<p class=\"success\">La tva par d&eacute;faut ".$_POST['variable_tva_old']." a &eacute;t&eacute; chang&eacute;e en tva ".$_POST['variable_tva_new']." avec succ&egrave;s.</p>";
            }else{
                $infos_tva .= "<p class=\"error\">La nouvelle tva par d&eacute;faut (".$_POST['variable_tva_old'].") doit être diff&eacute;rente de l&apos;ancienne.</p>";
                $error_tva[] = 'variable_tva_new';
            }
        }else{
            $infos_tva .= "<p class=\"error\">La nouvelle tva par d&eacute;faut qui remplace ".$_POST['variable_tva_old']." n&apos;est pas de type num&eacute;rique ('".$_POST['variable_tva_new']."').</p>";
            $error_tva[] = 'variable_tva_new';
        }
    }
}

$query_count_produit = "SELECT id, tva, prix, prix2 from produit";
$result_count_produit = mysql_query($query_count_produit);
$nb_produits = mysql_num_rows($result_count_produit);

//Action appelée pour sauvegarder la table produit dans la table tva_produit (permettra de faire un backup en cas de problème
if($_POST['action'] == "tva_sauvegarder"){
    
    //Si on a des produit à sauvegarder
    if($nb_produits > 0){
        //on vide d'abord notre table de backup
        $query_delete_tva = "DELETE FROM " . Tva::TABLE;
        mysql_query($query_delete_tva);
        
        //Pour chaque produit, on l'enregistre dans notre table de backup
        $query_insert_all = "INSERT INTO " . Tva::TABLE . " (id_produit, tva, prix, prix2) VALUES ";
        $count = 0;
        while($row_product = mysql_fetch_object($result_count_produit)){
            if($count > 0)
                $query_insert_all .= ", ";
                
            $query_insert_all .= "(" . $row_product->id .
                                ", " . $row_product->tva .
                                ", " . $row_product->prix .
                                ", " . $row_product->prix2 . ")";
            $count++;
        }
        
        //Execution de la requete
        mysql_query($query_insert_all);
        
        //On enregistre la variable tva aussi
        $query_delete_tva_variable = "DELETE FROM tva_variable";
        mysql_query($query_delete_tva_variable);
        
        $variable_tva = new Variable();
        $variable_tva->charger("tva"); //Compatible thelia 1.3
        $query_insert_tva_variable = "INSERT INTO tva_variable(nom, valeur) VALUES(
                                     '".$variable_tva->nom."',
                                     '".$variable_tva->valeur."'
        )";
        mysql_query($query_insert_tva_variable);
        
        $infos_sauvegarde = "<p class=\"success\">Votre base de donn&eacute;es &agrave; &eacute;t&eacute; enregistr&eacute;e avec succ&egrave;s.</p>";
    }else{
        $infos_sauvegarde = "<p class=\"error\">Aucun produits trouv&eacute;s... Sauvegarde impossible</p>";
    }
}

$query_count_tva_produit = "SELECT * FROM " . Tva::TABLE;
$result_count_tva_produit = mysql_query($query_count_tva_produit);
$nb_tva_produits = mysql_num_rows($result_count_tva_produit);

//Action appelée pour restaurer la table produit grâce à notre sauvegarde réalisée précédement
if($_POST['action'] == "tva_backup"){
    
    if($nb_tva_produits > 0){
        while($row_tva_product = mysql_fetch_object($result_count_tva_produit)){
            $produit = new Produit();
            $produit->charger_id($row_tva_product->id_produit);
            $produit->tva = $row_tva_product->tva;
            $produit->prix = $row_tva_product->prix;
            $produit->prix2 = $row_tva_product->prix2;
            $produit->maj();
        }
        
        //Variable à remettre à jour aussi
        $query_tva_variable = "SELECT * FROM tva_variable";
        $result_tva_variable = mysql_query($query_tva_variable);
        if(mysql_num_rows($result_tva_variable) > 0){
            $variable_tva = new Variable();
            $variable_tva->charger("tva"); //Compatible thelia 1.3
            while($row_tva_variable = mysql_fetch_object($result_tva_variable)){
                $variable_tva->valeur = $row_tva_variable->valeur; 
            }
            $variable_tva->maj();
        }
        $infos_backup = "<p class=\"success\">Restauration termin&eacute;e avec succ&egrave;s. Vos TVA et prix TTC sont retourn&eacute;s &agrave; leurs anciennes valeurs</p>";
    }else{
        $infos_backup = "<p class=\"error\">Aucune sauvegarde trouv&eacute;e... Restauration impossible.</p>";
    }
}



$query_tva = "SELECT DISTINCT(tva) from produit";
$result_tva = mysql_query($query_tva);
$tvas = array();
while($row_tva = mysql_fetch_object($result_tva)){
	$tvas[] = $row_tva;
}

//On n'oublie pas la table variable
$variable_tva = new Variable();
$variable_tva->charger("tva"); //Compatible thelia 1.3

?>